aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
diff options
context:
space:
mode:
Diffstat (limited to 'target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom')
-rw-r--r--target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom67
1 files changed, 67 insertions, 0 deletions
diff --git a/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom b/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
new file mode 100644
index 0000000..0e02177
--- /dev/null
+++ b/target/linux/ramips/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
@@ -0,0 +1,67 @@
+#!/bin/sh
+
+rt2x00_eeprom_die() {
+ echo "rt2x00 eeprom: " "$*"
+ exit 1
+}
+
+rt2x00_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local mtd
+
+ . /lib/functions.sh
+
+ mtd=$(find_mtd_part $part)
+ [ -n "$mtd" ] || \
+ rt2x00_eeprom_die "no mtd device found for partition $part"
+
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=$count 2>/dev/null || \
+ rt2x00_eeprom_die "failed to extract from $mtd"
+}
+
+rt2x00_eeprom_set_macaddr() {
+ local macaddr=$1
+
+ [ -n "$macaddr" ] || \
+ rt2x00_eeprom_die "invalid wlan mac address"
+
+ macaddr_2bin $macaddr | dd of=/lib/firmware/$FIRMWARE \
+ conv=notrunc bs=1 seek=4 count=6 2>/dev/null || \
+ rt2x00_eeprom_die "failed to write mac address to eeprom file"
+}
+
+FW="/lib/firmware/$FIRMWARE"
+[ -e "$FW" ] && exit 0
+
+. /lib/ramips.sh
+. /lib/functions/system.sh
+
+board=$(ramips_board_name)
+
+case "$FIRMWARE" in
+"soc_wmac.eeprom")
+ case $board in
+ *)
+ rt2x00_eeprom_die "Please define mtd-eeprom in $board DTS file!"
+ ;;
+ esac
+ ;;
+
+"rt2x00pci_1_0.eeprom")
+ case $board in
+ cy-swr1100)
+ rt2x00_eeprom_extract "factory" 8192 512
+ ;;
+ br-6475nd | rt-n56u | whr-600d | whr-1166d)
+ rt2x00_eeprom_extract "factory" 32768 512
+ ;;
+ tiny-ac)
+ local wifi_mac=$(mtd_get_mac_ascii u-boot-env INIC_MAC_ADDR)
+ rt2x00_eeprom_extract "factory" 0 512
+ rt2x00_eeprom_set_macaddr $wifi_mac
+ ;;
+ esac
+ ;;
+esac